const std = @import("std");
const Module = @import("../module.zig");
const Self = @This();

module: Module,

pub fn init(allocator: std.mem.Allocator) Self {
    return .{
        .module = .{
            .allocator = allocator,
            .getJsonFn = getJson,
        },
    };
}

pub fn getJson(module: *const Module) !Module.JSON {
    const self = @fieldParentPtr(Self, "module", module);

    var loadavg_file = try std.fs.openFileAbsolute("/proc/loadavg", .{});
    defer loadavg_file.close();

    const loadavg_string = try loadavg_file.reader().readAllAlloc(self.module.allocator, 64);
    var loadavg_split = std.mem.splitScalar(u8, loadavg_string[0 .. loadavg_string.len - 1], ' ');
    var loadavg = try std.fmt.parseFloat(f32, loadavg_split.first());

    return .{
        .full_text = try std.fmt.allocPrint(self.module.allocator, "{d:0>1.2}", .{loadavg}),
    };
}
